namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_io_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_IO_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_IO_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_conversion.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_custom_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#define BLOCK_READ_FUNC_0 get_half_byte)==""\n"
R"==(#define BLOCK_READ_FUNC_1 intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_READ_FUNC_2 intel_sub_group_block_read_us)==""\n"
R"==(#define BLOCK_READ_FUNC_4 intel_sub_group_block_read)==""\n"
R"==(#define BLOCK_READ_FUNC_8 intel_sub_group_block_read_ul)==""\n"
R"==(#define BLOCK_WRITE_FUNC_1 intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_WRITE_FUNC_2 intel_sub_group_block_write_us)==""\n"
R"==(#define BLOCK_WRITE_FUNC_4 intel_sub_group_block_write)==""\n"
R"==(#define BLOCK_WRITE_FUNC_8 intel_sub_group_block_write_ul)==""\n"
R"==(#define BLOCK_DT_0 uchar)==""\n"
R"==(#define BLOCK_DT_1 uchar)==""\n"
R"==(#define BLOCK_DT_2 ushort)==""\n"
R"==(#define BLOCK_DT_4 uint)==""\n"
R"==(#define BLOCK_DT_8 ulong)==""\n"
R"==(#define SIZE_undef_data 1)==""\n"
R"==(#define SIZE_char 1)==""\n"
R"==(#define SIZE_uchar 1)==""\n"
R"==(#define SIZE_f8_e5m2 1)==""\n"
R"==(#define SIZE_f8_e4m3 1)==""\n"
R"==(#define SIZE_f4_e2m1 0)==""\n"
R"==(#define SIZE_f4_e3m0 0)==""\n"
R"==(#define SIZE_e8m0 1)==""\n"
R"==(#define SIZE_bf16 2)==""\n"
R"==(#define SIZE_half 2)==""\n"
R"==(#define SIZE_int 4)==""\n"
R"==(#define SIZE_float 4)==""\n"
R"==(#define SIZE_double 8)==""\n"
R"==(#define SIZE(dt) CONCAT2(SIZE_, dt))==""\n"
R"==(#define BLOCK_DT(dt) CONCAT2(BLOCK_DT_, SIZE(dt)))==""\n"
R"==(#define BLOCK_READ_FUNC(dt) CONCAT2(BLOCK_READ_FUNC_, SIZE(dt)))==""\n"
R"==(#define BLOCK_WRITE_FUNC(dt) CONCAT2(BLOCK_WRITE_FUNC_, SIZE(dt)))==""\n"
R"==(#define BLOCK_DT_N(dt, n) CONCAT2(BLOCK_DT(dt), n))==""\n"
R"==(#define BLOCK_READ_FUNC_N(dt, n) CONCAT2(BLOCK_READ_FUNC(dt), n))==""\n"
R"==(#define BLOCK_WRITE_FUNC_N(dt, n) CONCAT2(BLOCK_WRITE_FUNC(dt), n))==""\n"
R"==(#define DECLARE_AS_BLOCK(t) \)==""\n"
R"==(BLOCK_DT(t) __attribute__((overloadable)) as_block_data(t a) { \)==""\n"
R"==(return CONCAT2(as_, BLOCK_DT(t))(a); \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_AS_STRUCT_BLOCK(t) \)==""\n"
R"==(BLOCK_DT(t) __attribute__((overloadable)) as_block_data(t a) { \)==""\n"
R"==(return CONCAT2(as_, BLOCK_DT(t))(a.data); \)==""\n"
R"==(})==""\n"
R"==(DECLARE_AS_BLOCK(char))==""\n"
R"==(DECLARE_AS_BLOCK(uchar))==""\n"
R"==(DECLARE_AS_STRUCT_BLOCK(f8_e5m2))==""\n"
R"==(DECLARE_AS_STRUCT_BLOCK(f8_e4m3))==""\n"
R"==(DECLARE_AS_STRUCT_BLOCK(e8m0))==""\n"
R"==(DECLARE_AS_STRUCT_BLOCK(bf16))==""\n"
R"==(DECLARE_AS_BLOCK(half))==""\n"
R"==(DECLARE_AS_BLOCK(int))==""\n"
R"==(DECLARE_AS_BLOCK(float))==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(DECLARE_AS_BLOCK(double))==""\n"
R"==(#endif)==""\n"
R"==(#undef DECLARE_AS_BLOCK)==""\n"
R"==(#undef DECLARE_AS_STRUCT_BLOCK)==""\n"
R"==(#define DEF_load(dst_dt, src_dt) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(load(__private dst_dt *dst, __global const src_dt *val) { \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(} \)==""\n"
R"==(dst_dt __attribute__((overloadable, warn_unused_result)) \)==""\n"
R"==(load(dst_dt dst, __global src_dt *val) { \)==""\n"
R"==(return CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(} \)==""\n"
R"==(dst_dt __attribute__((overloadable, warn_unused_result)) \)==""\n"
R"==(load(dst_dt dst, __global const src_dt *val) { \)==""\n"
R"==(return CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_load( \)==""\n"
R"==(__private dst_dt *dst, __global const src_dt *src, int n) { \)==""\n"
R"==(__attribute__((opencl_unroll_hint)) while (n >= 8) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(src_dt) *)(src); \)==""\n"
R"==(BLOCK_DT_N(src_dt, 8) \)==""\n"
R"==(block_val = BLOCK_READ_FUNC_N(src_dt, 8)(data); \)==""\n"
R"==(for (int i = 0; i < 8; i++) { \)==""\n"
R"==(src_dt src_val = CONCAT2(as_, src_dt)(block_val[i]); \)==""\n"
R"==(dst[i] = CONCAT2(into_, dst_dt)(src_val); \)==""\n"
R"==(} \)==""\n"
R"==(dst += 8; \)==""\n"
R"==(src += 8 * get_max_sub_group_size(); \)==""\n"
R"==(n -= 8; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 4) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(src_dt) *)(src); \)==""\n"
R"==(BLOCK_DT_N(src_dt, 4) \)==""\n"
R"==(block_val = BLOCK_READ_FUNC_N(src_dt, 4)(data); \)==""\n"
R"==(for (int i = 0; i < 4; i++) { \)==""\n"
R"==(src_dt src_val = CONCAT2(as_, src_dt)(block_val[i]); \)==""\n"
R"==(dst[i] = CONCAT2(into_, dst_dt)(src_val); \)==""\n"
R"==(} \)==""\n"
R"==(dst += 4; \)==""\n"
R"==(src += 4 * get_max_sub_group_size(); \)==""\n"
R"==(n -= 4; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 2) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(src_dt) *)(src); \)==""\n"
R"==(BLOCK_DT_N(src_dt, 2) \)==""\n"
R"==(block_val = BLOCK_READ_FUNC_N(src_dt, 2)(data); \)==""\n"
R"==(for (int i = 0; i < 2; i++) { \)==""\n"
R"==(src_dt src_val = CONCAT2(as_, src_dt)(block_val[i]); \)==""\n"
R"==(dst[i] = CONCAT2(into_, dst_dt)(src_val); \)==""\n"
R"==(} \)==""\n"
R"==(dst += 2; \)==""\n"
R"==(src += 2 * get_max_sub_group_size(); \)==""\n"
R"==(n -= 2; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 1) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(src_dt) *)(src); \)==""\n"
R"==(BLOCK_DT(src_dt) \)==""\n"
R"==(block_val = BLOCK_READ_FUNC(src_dt)(data); \)==""\n"
R"==(src_dt src_val = CONCAT2(as_, src_dt)(block_val); \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(src_val); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_load( \)==""\n"
R"==(__private dst_dt *dst, __global src_dt *src) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data = (__global BLOCK_DT(src_dt) *)(src); \)==""\n"
R"==(BLOCK_DT(src_dt) block_val = BLOCK_READ_FUNC(src_dt)(data); \)==""\n"
R"==(src_dt src_val = CONCAT2(as_, src_dt)(block_val); \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(src_val); \)==""\n"
R"==(})==""\n"
R"==(#define DEF_load_half_byte(dst_dt, src_dt) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(load(__private dst_dt *dst, __global src_dt *val, off_t off) { \)==""\n"
R"==(__global BLOCK_DT(src_dt) *data = (__global BLOCK_DT(src_dt) *)(val); \)==""\n"
R"==(BLOCK_DT(src_dt) block_val = BLOCK_READ_FUNC(src_dt)(data, off); \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(block_val); \)==""\n"
R"==(})==""\n"
R"==(#define DEF_write(dst_dt, src_dt) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(write(__global dst_dt *dst, __private const src_dt *val) { \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(} \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(write(__global dst_dt *dst, __private src_dt val) { \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(val); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_write( \)==""\n"
R"==(__global dst_dt *dst, __private const src_dt *src, int n) { \)==""\n"
R"==(__attribute__((opencl_unroll_hint)) while (n >= 8) { \)==""\n"
R"==(BLOCK_DT_N(dst_dt, 8) block_val; \)==""\n"
R"==(for (int i = 0; i < 8; i++) { \)==""\n"
R"==(dst_dt val = CONCAT2(into_, dst_dt)(src[i]); \)==""\n"
R"==(block_val[i] = as_block_data(val); \)==""\n"
R"==(} \)==""\n"
R"==(__global BLOCK_DT(dst_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(dst_dt) *)(dst); \)==""\n"
R"==(BLOCK_WRITE_FUNC_N(dst_dt, 8)(data, block_val); \)==""\n"
R"==(dst += 8 * get_max_sub_group_size(); \)==""\n"
R"==(src += 8; \)==""\n"
R"==(n -= 8; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 4) { \)==""\n"
R"==(BLOCK_DT_N(dst_dt, 4) block_val; \)==""\n"
R"==(for (int i = 0; i < 4; i++) { \)==""\n"
R"==(dst_dt val = CONCAT2(into_, dst_dt)(src[i]); \)==""\n"
R"==(block_val[i] = as_block_data(val); \)==""\n"
R"==(} \)==""\n"
R"==(__global BLOCK_DT(dst_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(dst_dt) *)(dst); \)==""\n"
R"==(BLOCK_WRITE_FUNC_N(dst_dt, 4)(data, block_val); \)==""\n"
R"==(dst += 4 * get_max_sub_group_size(); \)==""\n"
R"==(src += 4; \)==""\n"
R"==(n -= 4; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 2) { \)==""\n"
R"==(BLOCK_DT_N(dst_dt, 2) block_val; \)==""\n"
R"==(for (int i = 0; i < 2; i++) { \)==""\n"
R"==(dst_dt val = CONCAT2(into_, dst_dt)(src[i]); \)==""\n"
R"==(block_val[i] = as_block_data(val); \)==""\n"
R"==(} \)==""\n"
R"==(__global BLOCK_DT(dst_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(dst_dt) *)(dst); \)==""\n"
R"==(BLOCK_WRITE_FUNC_N(dst_dt, 2)(data, block_val); \)==""\n"
R"==(dst += 2 * get_max_sub_group_size(); \)==""\n"
R"==(src += 2; \)==""\n"
R"==(n -= 2; \)==""\n"
R"==(} \)==""\n"
R"==(if (n >= 1) { \)==""\n"
R"==(BLOCK_DT(dst_dt) block_val; \)==""\n"
R"==(dst_dt val = CONCAT2(into_, dst_dt)(*src); \)==""\n"
R"==(block_val = as_block_data(val); \)==""\n"
R"==(__global BLOCK_DT(dst_dt) *data \)==""\n"
R"==(= (__global BLOCK_DT(dst_dt) *)(dst); \)==""\n"
R"==(BLOCK_WRITE_FUNC(dst_dt)(data, block_val); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(DEF_load(float, int);)==""\n"
R"==(DEF_load(float, float);)==""\n"
R"==(DEF_load(float, char);)==""\n"
R"==(DEF_load(float, uchar);)==""\n"
R"==(DEF_load(int, char);)==""\n"
R"==(DEF_load(int, uchar);)==""\n"
R"==(DEF_load(int, int);)==""\n"
R"==(DEF_load(float, bf16);)==""\n"
R"==(DEF_load(int, undef_data);)==""\n"
R"==(DEF_load(float, undef_data);)==""\n"
R"==(DEF_write(char, float);)==""\n"
R"==(DEF_write(uchar, float);)==""\n"
R"==(DEF_write(bf16, float);)==""\n"
R"==(DEF_write(float, float);)==""\n"
R"==(DEF_write(char, int);)==""\n"
R"==(DEF_write(uchar, int);)==""\n"
R"==(DEF_write(bf16, int);)==""\n"
R"==(DEF_write(int, int);)==""\n"
R"==(DEF_write(float, int);)==""\n"
R"==(DEF_write(int, float);)==""\n"
R"==(#ifdef cl_khr_fp16)==""\n"
R"==(DEF_load(half, half);)==""\n"
R"==(DEF_load(float, half);)==""\n"
R"==(DEF_write(half, float);)==""\n"
R"==(DEF_write(half, int);)==""\n"
R"==(DEF_write(half, half);)==""\n"
R"==(DEF_write(char, half);)==""\n"
R"==(DEF_write(uchar, half);)==""\n"
R"==(DEF_write(float, half);)==""\n"
R"==(DEF_write(bf16, half);)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(DEF_load(half, f8_e5m2);)==""\n"
R"==(DEF_load(float, f8_e5m2);)==""\n"
R"==(DEF_write(f8_e5m2, half);)==""\n"
R"==(DEF_write(f8_e5m2, float);)==""\n"
R"==(DEF_write(f8_e5m2, int);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_HF8)==""\n"
R"==(DEF_load(half, f8_e4m3);)==""\n"
R"==(DEF_load(float, f8_e4m3);)==""\n"
R"==(DEF_write(f8_e4m3, half);)==""\n"
R"==(DEF_write(f8_e4m3, float);)==""\n"
R"==(DEF_write(f8_e4m3, int);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_F4_E2M1)==""\n"
R"==(DEF_load_half_byte(half, f4_e2m1);)==""\n"
R"==(DEF_load_half_byte(float, f4_e2m1);)==""\n"
R"==(DEF_write(f4_e2m1, half);)==""\n"
R"==(DEF_write(f4_e2m1, float);)==""\n"
R"==(DEF_write(f4_e2m1, int);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_F4_E3M0)==""\n"
R"==(DEF_load_half_byte(half, f4_e3m0);)==""\n"
R"==(DEF_load_half_byte(float, f4_e3m0);)==""\n"
R"==(DEF_write(f4_e3m0, half);)==""\n"
R"==(DEF_write(f4_e3m0, float);)==""\n"
R"==(DEF_write(f4_e3m0, int);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_E8M0)==""\n"
R"==(DEF_load(float, e8m0);)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(DEF_load(double, undef_data);)==""\n"
R"==(DEF_load(float, double); )==""\n"
R"==(DEF_load(double, bf16);)==""\n"
R"==(DEF_load(double, float);)==""\n"
R"==(DEF_load(double, double);)==""\n"
R"==(DEF_write(char, double);)==""\n"
R"==(DEF_write(uchar, double);)==""\n"
R"==(DEF_write(bf16, double);)==""\n"
R"==(DEF_write(float, double);)==""\n"
R"==(DEF_write(double, double);)==""\n"
R"==(DEF_write(double, float);)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(cl_khr_fp16) && defined(cl_khr_fp64))==""\n"
R"==(DEF_load(double, half);)==""\n"
R"==(DEF_write(half, double);)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(DEF_load(double, f8_e5m2);)==""\n"
R"==(DEF_write(f8_e5m2, double);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_HF8)==""\n"
R"==(DEF_load(double, f8_e4m3);)==""\n"
R"==(DEF_write(f8_e4m3, double);)==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}