namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_types_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_TYPES_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_TYPES_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_custom_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_math_utils.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types_specific.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#define auto __auto_type)==""\n"
R"==(#define typeof(x) __typeof__(x))==""\n"
R"==(#define unroll_for __attribute__((opencl_unroll_hint)) for)==""\n"
R"==(#define unroll_for_by(factor) __attribute__((opencl_unroll_hint(factor))) for)==""\n"
R"==(#define unroll_2_for unroll_for_by(2))==""\n"
R"==(#define unroll_4_for unroll_for_by(4))==""\n"
R"==(#define unroll_8_for unroll_for_by(8))==""\n"
R"==(#define unroll_16_for unroll_for_by(16))==""\n"
R"==(#define for_ for)==""\n"
R"==(#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \)==""\n"
R"==(|| defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \)==""\n"
R"==(|| defined(BIA_DT_F16) || defined(ACC_DT_F16))==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F64)==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp64 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F64 == 1)==""\n"
R"==(#define AS_POST_OP_DATA_T(v) v)==""\n"
R"==(#else)==""\n"
R"==(#define AS_POST_OP_DATA_T(v) (float)(v))==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F32 == 1)==""\n"
R"==(#define DATA_T float)==""\n"
R"==(#define DATA2_T float2)==""\n"
R"==(#define DATA4_T float4)==""\n"
R"==(#define DATA8_T float8)==""\n"
R"==(#define DATA16_T float16)==""\n"
R"==(#define DATA_MAX FLT_MAX)==""\n"
R"==(#define DATA_MIN -DATA_MAX)==""\n"
R"==(#define DATA_ZERO 0.0f)==""\n"
R"==(#define DATA_ONE 1.0f)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) (float)(v))==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_float)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_float2)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_float4)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_float8)==""\n"
R"==(#define DATA_TO_REF convert_float)==""\n"
R"==(#define CONVERT_DATA_T convert_float)==""\n"
R"==(#define CONVERT_DATA2_T convert_float2)==""\n"
R"==(#define CONVERT_DATA4_T convert_float4)==""\n"
R"==(#define CONVERT_DATA8_T convert_float8)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write8)==""\n"
R"==(#define AS_DATA_T as_float)==""\n"
R"==(#define AS_DATA2_T as_float2)==""\n"
R"==(#define AS_DATA4_T as_float4)==""\n"
R"==(#define AS_DATA8_T as_float8)==""\n"
R"==(#define BLOCK_DATA_T uint)==""\n"
R"==(#define BLOCK_DATA2_T uint2)==""\n"
R"==(#define BLOCK_DATA4_T uint4)==""\n"
R"==(#define BLOCK_DATA8_T uint8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uint)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uint2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uint4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uint8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float)==""\n"
R"==(#elif DT_F64 == 1)==""\n"
R"==(#define DATA_T double)==""\n"
R"==(#define DATA2_T double2)==""\n"
R"==(#define DATA4_T double4)==""\n"
R"==(#define DATA8_T double8)==""\n"
R"==(#define DATA16_T double16)==""\n"
R"==(#define DATA_MAX DBL_MAX)==""\n"
R"==(#define DATA_MIN -DATA_MAX)==""\n"
R"==(#define DATA_ZERO 0.0)==""\n"
R"==(#define DATA_ONE 1.0)==""\n"
R"==(#define DEF_ACC_DATA_T double)==""\n"
R"==(#define DEF_ACC_DATA2_T double2)==""\n"
R"==(#define DEF_ACC_DATA4_T double4)==""\n"
R"==(#define DEF_ACC_DATA8_T double8)==""\n"
R"==(#define POST_OP_DATA_T double)==""\n"
R"==(#define TO_DATA_T(v) (double)(v))==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) (double)(v))==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_double2)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_double4)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_double8)==""\n"
R"==(#define DATA_TO_REF convert_float)==""\n"
R"==(#define CONVERT_DATA_T convert_double)==""\n"
R"==(#define CONVERT_DATA2_T convert_double2)==""\n"
R"==(#define CONVERT_DATA4_T convert_double4)==""\n"
R"==(#define CONVERT_DATA8_T convert_double8)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define BLOCK_DATA_T ulong)==""\n"
R"==(#define BLOCK_DATA2_T ulong2)==""\n"
R"==(#define BLOCK_DATA4_T ulong4)==""\n"
R"==(#define BLOCK_DATA8_T ulong8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_ulong)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_ulong2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_ulong4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_ulong8)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_ul)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_ul)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_ul2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_ul4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_ul8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_ul2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_ul4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_ul8)==""\n"
R"==(#define AS_DATA_T as_double)==""\n"
R"==(#define AS_DATA2_T as_double2)==""\n"
R"==(#define AS_DATA4_T as_double4)==""\n"
R"==(#define AS_DATA8_T as_double8)==""\n"
R"==(#define AS_ULONG as_ulong)==""\n"
R"==(#define AS_ULONG2 as_ulong2)==""\n"
R"==(#define AS_ULONG4 as_ulong4)==""\n"
R"==(#define AS_ULONG8 as_ulong8)==""\n"
R"==(#define FLT_ACC_DATA_T double)==""\n"
R"==(#define TO_FLT_ACC_DATA_T(v) (double)(v))==""\n"
R"==(#elif DT_F16 == 1)==""\n"
R"==(#define DATA_T half)==""\n"
R"==(#define DATA2_T half2)==""\n"
R"==(#define DATA4_T half4)==""\n"
R"==(#define DATA8_T half8)==""\n"
R"==(#define DATA16_T half16)==""\n"
R"==(#define AS_DATA2_T as_half2)==""\n"
R"==(#define DATA_MAX HALF_MAX)==""\n"
R"==(#define DATA_MIN -DATA_MAX)==""\n"
R"==(#define DATA_ZERO 0.0h)==""\n"
R"==(#define DATA_ONE 1.0h)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T convert_half)==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_float)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_float2)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_float4)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_float8)==""\n"
R"==(#define DATA_TO_REF convert_half)==""\n"
R"==(#define CONVERT_DATA_T convert_half)==""\n"
R"==(#define CONVERT_DATA2_T convert_half2)==""\n"
R"==(#define CONVERT_DATA4_T convert_half4)==""\n"
R"==(#define CONVERT_DATA8_T convert_half8)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_us)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_us)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_us2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_us4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_us8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_us2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_us4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_us8)==""\n"
R"==(#define AS_DATA_T as_half)==""\n"
R"==(#define AS_DATA2_T as_half2)==""\n"
R"==(#define AS_DATA4_T as_half4)==""\n"
R"==(#define AS_DATA8_T as_half8)==""\n"
R"==(#define BLOCK_DATA_T ushort)==""\n"
R"==(#define BLOCK_DATA2_T ushort2)==""\n"
R"==(#define BLOCK_DATA4_T ushort4)==""\n"
R"==(#define BLOCK_DATA8_T ushort8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_ushort)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_ushort2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_ushort4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_ushort8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float)==""\n"
R"==(#elif DT_BF16 == 1)==""\n"
R"==(#if WITH_PUNNING)==""\n"
R"==(#define DATA_T ushort)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_T bf16)==""\n"
R"==(#endif)==""\n"
R"==(#define DATA2_T ushort2)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define DATA2_T ushort2)==""\n"
R"==(#define DATA4_T ushort4)==""\n"
R"==(#define DATA8_T ushort8)==""\n"
R"==(#define DATA16_T ushort16)==""\n"
R"==(#define DATA_MAX (ushort)0x7F7F)==""\n"
R"==(#define DATA_MIN (ushort)0xFF7F)==""\n"
R"==(#define DATA_ZERO (ushort)0x0000)==""\n"
R"==(#define DATA_ONE (ushort)0x3F80)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define TO_DATA_T cvt_f32_to_bf16)==""\n"
R"==(#define TO_DEF_ACC_DATA_T cvt_bf16_to_f32)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T cvt_bf16_to_f32)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T cvt_bf16_to_f32)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T cvt_bf16_to_f32)==""\n"
R"==(#define DATA_TO_REF cvt_bf16_to_f32)==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_f32_to_bf16(convert_float(v)))==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_f32_to_bf16(convert_float2(v)))==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_f32_to_bf16(convert_float4(v)))==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_f32_to_bf16(convert_float8(v)))==""\n"
R"==(#define CONVERT_FLOAT_T cvt_bf16_to_f32)==""\n"
R"==(#define CONVERT_FLOAT2_T cvt_bf16_to_f32)==""\n"
R"==(#define CONVERT_FLOAT4_T cvt_bf16_to_f32)==""\n"
R"==(#define CONVERT_FLOAT8_T cvt_bf16_to_f32)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_us)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_us)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_us2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_us4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_us8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_us2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_us4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_us8)==""\n"
R"==(#define AS_DATA_T as_ushort)==""\n"
R"==(#define AS_DATA2_T as_ushort2)==""\n"
R"==(#define AS_DATA4_T as_ushort4)==""\n"
R"==(#define AS_DATA8_T as_ushort8)==""\n"
R"==(#define BLOCK_DATA_T ushort)==""\n"
R"==(#define BLOCK_DATA2_T ushort2)==""\n"
R"==(#define BLOCK_DATA4_T ushort4)==""\n"
R"==(#define BLOCK_DATA8_T ushort8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_ushort)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_ushort2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_ushort4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_ushort8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T cvt_bf16_to_f32)==""\n"
R"==(#elif DT_BF8 == 1)==""\n"
R"==(#if WITH_PUNNING)==""\n"
R"==(#define DATA_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_T f8_e5m2)==""\n"
R"==(#endif)==""\n"
R"==(#define DATA2_T uchar2)==""\n"
R"==(#define DATA4_T uchar4)==""\n"
R"==(#define DATA8_T uchar8)==""\n"
R"==(#define DATA16_T uchar16)==""\n"
R"==(#define DATA_MAX (uchar)0x7B)==""\n"
R"==(#define DATA_MIN (uchar)0xFB)==""\n"
R"==(#define DATA_ZERO (uchar)0x00)==""\n"
R"==(#define DATA_ONE (uchar)0x3C)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) cvt_hf_to_f8_e5m2(convert_half(v))==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA2_T(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA4_T(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA8_T(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define DATA_TO_REF(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_hf_to_f8_e5m2(convert_half(v)))==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_hf_to_f8_e5m2(convert_half2(v)))==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_hf_to_f8_e5m2(convert_half4(v)))==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_hf_to_f8_e5m2(convert_half8(v)))==""\n"
R"==(#define CONVERT_FLOAT_T(v) convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT2_T(v) convert_float2(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT4_T(v) convert_float4(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT8_T(v) convert_float8(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_uchar)==""\n"
R"==(#define AS_DATA2_T as_uchar2)==""\n"
R"==(#define AS_DATA4_T as_uchar4)==""\n"
R"==(#define AS_DATA8_T as_uchar8)==""\n"
R"==(#define AS_DATA16_T as_uchar16)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define MMAD_DATA_T half)==""\n"
R"==(#define MMAD_DATA4_T half4)==""\n"
R"==(#define MMAD_DATA8_T half8)==""\n"
R"==(#define MMAD_ACC_DATA4_T half4)==""\n"
R"==(#define MMAD_ACC_DATA8_T half8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float(cvt_f8_e5m2_to_hf(v)))==""\n"
R"==(#elif DT_HF8 == 1)==""\n"
R"==(#if WITH_PUNNING)==""\n"
R"==(#define DATA_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_T f8_e4m3)==""\n"
R"==(#endif)==""\n"
R"==(#define DATA2_T uchar2)==""\n"
R"==(#define DATA4_T uchar4)==""\n"
R"==(#define DATA8_T uchar8)==""\n"
R"==(#define DATA16_T uchar16)==""\n"
R"==(#define DATA_MAX (uchar)0x7E)==""\n"
R"==(#define DATA_MIN (uchar)0xFE)==""\n"
R"==(#define DATA_ZERO (uchar)0x00)==""\n"
R"==(#define DATA_ONE (uchar)0x38)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) cvt_hf_to_f8_e4m3(convert_half(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA2_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA4_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA8_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define DATA_TO_REF(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_hf_to_f8_e4m3(convert_half(v)))==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_hf_to_f8_e4m3(convert_half2(v)))==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_hf_to_f8_e4m3(convert_half4(v)))==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_hf_to_f8_e4m3(convert_half8(v)))==""\n"
R"==(#define CONVERT_FLOAT_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT2_T(v) convert_float2(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT4_T(v) convert_float4(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define CONVERT_FLOAT8_T(v) convert_float8(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_uchar)==""\n"
R"==(#define AS_DATA2_T as_uchar2)==""\n"
R"==(#define AS_DATA4_T as_uchar4)==""\n"
R"==(#define AS_DATA8_T as_uchar8)==""\n"
R"==(#define AS_DATA16_T as_uchar16)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define MMAD_DATA_T half)==""\n"
R"==(#define MMAD_DATA4_T half4)==""\n"
R"==(#define MMAD_DATA8_T half8)==""\n"
R"==(#define MMAD_ACC_DATA4_T half4)==""\n"
R"==(#define MMAD_ACC_DATA8_T half8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T(v) convert_float(cvt_f8_e4m3_to_hf(v)))==""\n"
R"==(#elif DT_F4_E3M0 == 1)==""\n"
R"==(#if WITH_PUNNING)==""\n"
R"==(#define DATA_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_T f4_e3m0)==""\n"
R"==(#endif)==""\n"
R"==(#define DATA2_T uchar2)==""\n"
R"==(#define DATA4_T uchar4)==""\n"
R"==(#define DATA8_T uchar8)==""\n"
R"==(#define DATA16_T uchar16)==""\n"
R"==(#define DATA_MAX (uchar)0x07)==""\n"
R"==(#define DATA_MIN (uchar)0x08)==""\n"
R"==(#define DATA_ZERO (uchar)0x00)==""\n"
R"==(#define DATA_ONE (uchar)0x03)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) cvt_f32_to_f4_e3m0((v)))==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA2_T(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA4_T(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA8_T(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#define DATA_TO_REF(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_f32_to_f4_e3m0(v))==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_f32_to_f4_e3m0(v))==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_f32_to_f4_e3m0(v))==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_f32_to_f4_e3m0(v))==""\n"
R"==(#define CONVERT_FLOAT_T(v) cvt_f4_e3m0_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT2_T(v) cvt_f4_e3m0_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT4_T(v) cvt_f4_e3m0_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT8_T(v) cvt_f4_e3m0_to_f32(v))==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_uchar)==""\n"
R"==(#define AS_DATA2_T as_uchar2)==""\n"
R"==(#define AS_DATA4_T as_uchar4)==""\n"
R"==(#define AS_DATA8_T as_uchar8)==""\n"
R"==(#define AS_DATA16_T as_uchar16)==""\n"
R"==(#define AS_UINT_T as_uchar)==""\n"
R"==(#define AS_UINT2_T as_uchar2)==""\n"
R"==(#define AS_UINT4_T as_uchar4)==""\n"
R"==(#define AS_UINT8_T as_uchar8)==""\n"
R"==(#define AS_INT8_T as_uint8)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T(v) (cvt_f4_e3m0_to_f32(v)))==""\n"
R"==(#elif DT_F4_E2M1 == 1)==""\n"
R"==(#if WITH_PUNNING)==""\n"
R"==(#define DATA_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_T f4_e2m1)==""\n"
R"==(#endif)==""\n"
R"==(#define DATA2_T uchar2)==""\n"
R"==(#define DATA4_T uchar4)==""\n"
R"==(#define DATA8_T uchar8)==""\n"
R"==(#define DATA16_T uchar16)==""\n"
R"==(#define DATA_MAX (uchar)0x07)==""\n"
R"==(#define DATA_MIN (uchar)0x01)==""\n"
R"==(#define DATA_ZERO (uchar)0x00)==""\n"
R"==(#define DATA_ONE (uchar)0x02)==""\n"
R"==(#define DEF_ACC_DATA_T float)==""\n"
R"==(#define DEF_ACC_DATA2_T float2)==""\n"
R"==(#define DEF_ACC_DATA4_T float4)==""\n"
R"==(#define DEF_ACC_DATA8_T float8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) cvt_f32_to_f4_e2m1((v)))==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA2_T(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA4_T(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#define TO_DEF_ACC_DATA8_T(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#define DATA_TO_REF(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_f32_to_f4_e2m1(v))==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_f32_to_f4_e2m1(v))==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_f32_to_f4_e2m1(v))==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_f32_to_f4_e2m1(v))==""\n"
R"==(#define CONVERT_FLOAT_T(v) cvt_f4_e2m1_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT2_T(v) cvt_f4_e2m1_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT4_T(v) cvt_f4_e2m1_to_f32(v))==""\n"
R"==(#define CONVERT_FLOAT8_T(v) cvt_f4_e2m1_to_f32(v))==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_uchar)==""\n"
R"==(#define AS_DATA2_T as_uchar2)==""\n"
R"==(#define AS_DATA4_T as_uchar4)==""\n"
R"==(#define AS_DATA8_T as_uchar8)==""\n"
R"==(#define AS_DATA16_T as_uchar16)==""\n"
R"==(#define AS_UINT_T as_uchar)==""\n"
R"==(#define AS_UINT2_T as_uchar2)==""\n"
R"==(#define AS_UINT4_T as_uchar4)==""\n"
R"==(#define AS_UINT8_T as_uchar8)==""\n"
R"==(#define AS_INT8_T as_uint8)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T(v) (cvt_f4_e2m1_to_f32(v)))==""\n"
R"==(#elif DT_S8 == 1)==""\n"
R"==(#define DATA_T char)==""\n"
R"==(#define DATA2_T char2)==""\n"
R"==(#define DATA4_T char4)==""\n"
R"==(#define DATA8_T char8)==""\n"
R"==(#define DATA16_T char16)==""\n"
R"==(#define DATA_MAX CHAR_MAX)==""\n"
R"==(#define DATA_MIN CHAR_MIN)==""\n"
R"==(#define DATA_ZERO 0)==""\n"
R"==(#define DATA_ONE 1)==""\n"
R"==(#define INT8_T int8)==""\n"
R"==(#define DEF_ACC_DATA_T int)==""\n"
R"==(#define DEF_ACC_DATA2_T int2)==""\n"
R"==(#define DEF_ACC_DATA4_T int4)==""\n"
R"==(#define DEF_ACC_DATA8_T int8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) convert_char_sat_rte(v))==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte)==""\n"
R"==(#define DATA_TO_REF convert_float)==""\n"
R"==(#define CONVERT_DATA_T convert_char_sat_rte)==""\n"
R"==(#define CONVERT_DATA2_T convert_char2_sat_rte)==""\n"
R"==(#define CONVERT_DATA4_T convert_char4_sat_rte)==""\n"
R"==(#define CONVERT_DATA8_T convert_char8_sat_rte)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_char)==""\n"
R"==(#define AS_DATA2_T as_char2)==""\n"
R"==(#define AS_DATA4_T as_char4)==""\n"
R"==(#define AS_DATA8_T as_char8)==""\n"
R"==(#define AS_DATA16_T as_char16)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float)==""\n"
R"==(#elif DT_U8 == 1)==""\n"
R"==(#define DATA_T uchar)==""\n"
R"==(#define DATA2_T uchar2)==""\n"
R"==(#define DATA4_T uchar4)==""\n"
R"==(#define DATA8_T uchar8)==""\n"
R"==(#define DATA16_T uchar16)==""\n"
R"==(#define DATA_MAX UCHAR_MAX)==""\n"
R"==(#define DATA_MIN 0)==""\n"
R"==(#define DATA_ZERO 0)==""\n"
R"==(#define DATA_ONE 1)==""\n"
R"==(#define INT8_T uint8)==""\n"
R"==(#define DEF_ACC_DATA_T int)==""\n"
R"==(#define DEF_ACC_DATA2_T int2)==""\n"
R"==(#define DEF_ACC_DATA4_T int4)==""\n"
R"==(#define DEF_ACC_DATA8_T int8)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define TO_DATA_T(v) convert_uchar_sat_rte(v))==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte)==""\n"
R"==(#define DATA_TO_REF convert_float)==""\n"
R"==(#define CONVERT_DATA_T convert_uchar_sat_rte)==""\n"
R"==(#define CONVERT_DATA2_T convert_uchar2_sat_rte)==""\n"
R"==(#define CONVERT_DATA4_T convert_uchar4_sat_rte)==""\n"
R"==(#define CONVERT_DATA8_T convert_uchar8_sat_rte)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define AS_DATA_T as_uchar)==""\n"
R"==(#define AS_DATA2_T as_uchar2)==""\n"
R"==(#define AS_DATA4_T as_uchar4)==""\n"
R"==(#define AS_DATA8_T as_uchar8)==""\n"
R"==(#define AS_DATA16_T as_uchar16)==""\n"
R"==(#define BLOCK_DATA_T uchar)==""\n"
R"==(#define BLOCK_DATA2_T uchar2)==""\n"
R"==(#define BLOCK_DATA4_T uchar4)==""\n"
R"==(#define BLOCK_DATA8_T uchar8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float)==""\n"
R"==(#elif DT_S32 == 1)==""\n"
R"==(#define DATA_T int)==""\n"
R"==(#define DATA2_T int2)==""\n"
R"==(#define DATA4_T int4)==""\n"
R"==(#define DATA8_T int8)==""\n"
R"==(#define DATA16_T int16)==""\n"
R"==(#define DATA_MAX INT_MAX)==""\n"
R"==(#define DATA_MIN INT_MIN)==""\n"
R"==(#define DATA_ZERO 0)==""\n"
R"==(#define DATA_ONE 1)==""\n"
R"==(#define DATA_TO_REF convert_float)==""\n"
R"==(#define TO_DATA_T(v) convert_int_sat_rte)==""\n"
R"==(#define TO_DATA8_T(v) convert_int8_sat_rte)==""\n"
R"==(#define CONVERT_DATA_T convert_int_sat_rte)==""\n"
R"==(#define CONVERT_DATA2_T convert_int2_sat_rte)==""\n"
R"==(#define CONVERT_DATA4_T convert_int4_sat_rte)==""\n"
R"==(#define CONVERT_DATA8_T convert_int8_sat_rte)==""\n"
R"==(#define CONVERT_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2)==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4)==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8)==""\n"
R"==(#define DEF_ACC_DATA_T int)==""\n"
R"==(#define DEF_ACC_DATA2_T int2)==""\n"
R"==(#define DEF_ACC_DATA4_T int4)==""\n"
R"==(#define DEF_ACC_DATA8_T int8)==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte)==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte)==""\n"
R"==(#define POST_OP_DATA_T float)==""\n"
R"==(#define DATA_MIN INT_MIN)==""\n"
R"==(#define DATA_MAX INT_MAX)==""\n"
R"==(#define DATA_ZERO 0)==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read)==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write)==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read2)==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read4)==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read8)==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write2)==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write4)==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write8)==""\n"
R"==(#define AS_DATA_T as_int)==""\n"
R"==(#define AS_DATA2_T as_int2)==""\n"
R"==(#define AS_DATA4_T as_int4)==""\n"
R"==(#define AS_DATA8_T as_int8)==""\n"
R"==(#define BLOCK_DATA_T uint)==""\n"
R"==(#define BLOCK_DATA2_T uint2)==""\n"
R"==(#define BLOCK_DATA4_T uint4)==""\n"
R"==(#define BLOCK_DATA8_T uint8)==""\n"
R"==(#define AS_BLOCK_DATA_T as_uint)==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uint2)==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uint4)==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uint8)==""\n"
R"==(#define FLT_ACC_DATA_T float)==""\n"
R"==(#define TO_FLT_ACC_DATA_T convert_float)==""\n"
R"==(#elif !defined(DT_UNDEF))==""\n"
R"==(#error "Unexpected data type")==""\n"
R"==(#endif)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define VECT_DATA_T DATA_T)==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T)==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA_T)==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA_T)==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ)==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE)==""\n"
R"==(#define VECT_DST_BLOCK_WRITE BLOCK_WRITE_DST)==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read)==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write)==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc)==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc)==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA_T)==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T)==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T)==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T)==""\n"
R"==(#define CONVERT_VECTOR_DST_DATA_T CONVERT_DST_DATA_T)==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char)==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int)==""\n"
R"==(#define VECT_INT_T int)==""\n"
R"==(#define VECT_UINT_T uint)==""\n"
R"==(#define VECT_FLOAT_T float)==""\n"
R"==(#define VECT_CHAR_T char)==""\n"
R"==(#define AS_VECT_INT_T as_int)==""\n"
R"==(#define AS_VECT_UINT_T as_uint)==""\n"
R"==(#define AS_VECT_FLOAT_T as_float)==""\n"
R"==(#define AS_VECT_CHAR_T as_char)==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar)==""\n"
R"==(#elif VECT_DT_N == 2)==""\n"
R"==(#define VECT_DATA_T DATA2_T)==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T)==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA2_T)==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA2_T)==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ2)==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE2)==""\n"
R"==(#define VECT_DST_BLOCK_WRITE BLOCK_WRITE_DST2)==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read2)==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write2)==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc2)==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2)==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA2_T)==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T)==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T)==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T)==""\n"
R"==(#define CONVERT_VECTOR_DST_DATA_T CONVERT_DST_DATA2_T)==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char2)==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int2)==""\n"
R"==(#define VECT_INT_T int2)==""\n"
R"==(#define VECT_UINT_T uint2)==""\n"
R"==(#define VECT_FLOAT_T float2)==""\n"
R"==(#define VECT_CHAR_T char2)==""\n"
R"==(#define AS_VECT_INT_T as_int2)==""\n"
R"==(#define AS_VECT_UINT_T as_uint2)==""\n"
R"==(#define AS_VECT_FLOAT_T as_float2)==""\n"
R"==(#define AS_VECT_CHAR_T as_char2)==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar2)==""\n"
R"==(#elif VECT_DT_N == 4)==""\n"
R"==(#define VECT_DATA_T DATA4_T)==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T)==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA4_T)==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA4_T)==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ4)==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE4)==""\n"
R"==(#define VECT_DST_BLOCK_WRITE BLOCK_WRITE_DST4)==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read4)==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write4)==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc4)==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4)==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA4_T)==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T)==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T)==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T)==""\n"
R"==(#define CONVERT_VECTOR_DST_DATA_T CONVERT_DST_DATA4_T)==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char4)==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int4)==""\n"
R"==(#define VECT_INT_T int4)==""\n"
R"==(#define VECT_UINT_T uint4)==""\n"
R"==(#define VECT_FLOAT_T float4)==""\n"
R"==(#define VECT_CHAR_T char4)==""\n"
R"==(#define AS_VECT_INT_T as_int4)==""\n"
R"==(#define AS_VECT_UINT_T as_uint4)==""\n"
R"==(#define AS_VECT_FLOAT_T as_float4)==""\n"
R"==(#define AS_VECT_CHAR_T as_char4)==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar4)==""\n"
R"==(#elif VECT_DT_N == 8)==""\n"
R"==(#define VECT_DATA_T DATA8_T)==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T)==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA8_T)==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA8_T)==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ8)==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE8)==""\n"
R"==(#define VECT_DST_BLOCK_WRITE BLOCK_WRITE_DST8)==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read8)==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write8)==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc8)==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8)==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA8_T)==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T)==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T)==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T)==""\n"
R"==(#define CONVERT_VECTOR_DST_DATA_T CONVERT_DST_DATA8_T)==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char8)==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int8)==""\n"
R"==(#define VECT_INT_T int8)==""\n"
R"==(#define VECT_UINT_T uint8)==""\n"
R"==(#define VECT_FLOAT_T float8)==""\n"
R"==(#define VECT_CHAR_T char8)==""\n"
R"==(#define AS_VECT_INT_T as_int8)==""\n"
R"==(#define AS_VECT_UINT_T as_uint8)==""\n"
R"==(#define AS_VECT_FLOAT_T as_float8)==""\n"
R"==(#define AS_VECT_CHAR_T as_char8)==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar8)==""\n"
R"==(#endif)==""\n"
R"==(#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \)==""\n"
R"==(* CONCAT2(prefix, _S0_0)) \)==""\n"
R"==(+ (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \)==""\n"
R"==(* CONCAT2(prefix, _S0_1)) \)==""\n"
R"==(+ (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \)==""\n"
R"==(+ (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \)==""\n"
R"==(* CONCAT2(prefix, _S1_0)) \)==""\n"
R"==(+ (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \)==""\n"
R"==(* CONCAT2(prefix, _S1_1)) \)==""\n"
R"==(+ (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \)==""\n"
R"==(+ (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \)==""\n"
R"==(* CONCAT2(prefix, _S2_0)) \)==""\n"
R"==(+ (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \)==""\n"
R"==(* CONCAT2(prefix, _S2_1)) \)==""\n"
R"==(+ (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \)==""\n"
R"==(+ (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \)==""\n"
R"==(* CONCAT2(prefix, _S3_0)) \)==""\n"
R"==(+ (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \)==""\n"
R"==(* CONCAT2(prefix, _S3_1)) \)==""\n"
R"==(+ (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \)==""\n"
R"==(+ (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \)==""\n"
R"==(* CONCAT2(prefix, _S4_0)) \)==""\n"
R"==(+ (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \)==""\n"
R"==(* CONCAT2(prefix, _S4_1)) \)==""\n"
R"==(+ (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \)==""\n"
R"==(+ (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \)==""\n"
R"==(* CONCAT2(prefix, _S5_0)) \)==""\n"
R"==(+ (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \)==""\n"
R"==(* CONCAT2(prefix, _S5_1)) \)==""\n"
R"==(+ (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2))))==""\n"
R"==(#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define ALIAS(prefix) CONCAT2(prefix, _DT_ALIAS))==""\n"
R"==(#define BLOCK1_T uchar)==""\n"
R"==(#define BLOCK2_T ushort)==""\n"
R"==(#define BLOCK4_T uint)==""\n"
R"==(#define BLOCK8_T ulong)==""\n"
R"==(#define BLOCK_T(alias) CONCAT3(BLOCK, SIZEOF(alias), _T))==""\n"
R"==(#define BLOCK1_ALIAS UCHAR)==""\n"
R"==(#define BLOCK2_ALIAS USHORT)==""\n"
R"==(#define BLOCK4_ALIAS UINT)==""\n"
R"==(#define BLOCK8_ALIAS ULONG)==""\n"
R"==(#define BLOCK_ALIAS(prefix) CONCAT3(BLOCK, SIZEOF(ALIAS(prefix)), _ALIAS))==""\n"
R"==(#define SIZEOF_UCHAR 1)==""\n"
R"==(#define SIZEOF_CHAR 1)==""\n"
R"==(#define SIZEOF_BFLOAT 2)==""\n"
R"==(#define SIZEOF_HALF 2)==""\n"
R"==(#define SIZEOF_FLOAT 4)==""\n"
R"==(#define SIZEOF_DOUBLE 8)==""\n"
R"==(#define SIZEOF(alias) CONCAT2(SIZEOF_, alias))==""\n"
R"==(#define READ_UCHAR8 intel_sub_group_block_read_uc8)==""\n"
R"==(#define READ_USHORT8 intel_sub_group_block_read_us8)==""\n"
R"==(#define READ_UINT8 intel_sub_group_block_read8)==""\n"
R"==(#define READ_ULONG8 intel_sub_group_block_read_ul8)==""\n"
R"==(#define READ_BLOCK8(prefix, ptr) READ_BLOCK_N(prefix, 8)(ptr))==""\n"
R"==(#define READ_BLOCK_N(prefix, n) CONCAT3(READ_, BLOCK_ALIAS(prefix), n))==""\n"
R"==(#define WRITE_UCHAR8 intel_sub_group_block_write_uc8)==""\n"
R"==(#define WRITE_USHORT8 intel_sub_group_block_write_us8)==""\n"
R"==(#define WRITE_UINT8 intel_sub_group_block_write8)==""\n"
R"==(#define WRITE_ULONG8 intel_sub_group_block_write_ul8)==""\n"
R"==(#define WRITE_BLOCK8(prefix, ptr, val) WRITE_BLOCK_N(prefix, 8)(ptr, val))==""\n"
R"==(#define WRITE_BLOCK_N(prefix, n) CONCAT3(WRITE_, BLOCK_ALIAS(prefix), n))==""\n"
R"==(#define AS_UCHAR8 as_uchar8)==""\n"
R"==(#define AS_CHAR8 as_char8)==""\n"
R"==(#define AS_HALF8 as_half8)==""\n"
R"==(#define AS_USHORT8 as_ushort8)==""\n"
R"==(#define AS_BFLOAT8 as_ushort8)==""\n"
R"==(#define AS_FLOAT8 as_float8)==""\n"
R"==(#define AS_INT8 as_int8)==""\n"
R"==(#define AS_UINT8 as_uint8)==""\n"
R"==(#define AS_DOUBLE8 as_double8)==""\n"
R"==(#define BLOCK_TO_DATA8(prefix, val) BLOCK_TO_DATA_N(prefix, 8)(val))==""\n"
R"==(#define BLOCK_TO_DATA_N(prefix, n) CONCAT3(AS_, ALIAS(prefix), n))==""\n"
R"==(#define DATA_TO_BLOCK8(prefix, val) DATA_TO_BLOCK_N(prefix, 8)(val))==""\n"
R"==(#define DATA_TO_BLOCK_N(prefix, n) CONCAT3(AS_, BLOCK_ALIAS(prefix), n))==""\n"
R"==(#define UCHAR_TO_FLOAT1 convert_float)==""\n"
R"==(#define UCHAR_TO_FLOAT8 convert_float8)==""\n"
R"==(#define FLOAT_TO_UCHAR1 convert_uchar_sat_rte)==""\n"
R"==(#define FLOAT_TO_UCHAR8 convert_uchar8_sat_rte)==""\n"
R"==(#define CHAR_TO_FLOAT1 convert_float)==""\n"
R"==(#define CHAR_TO_FLOAT8 convert_float8)==""\n"
R"==(#define FLOAT_TO_CHAR1 convert_char_sat_rte)==""\n"
R"==(#define FLOAT_TO_CHAR8 convert_char8_sat_rte)==""\n"
R"==(#define HALF_TO_FLOAT1 convert_float)==""\n"
R"==(#define HALF_TO_FLOAT8 convert_float8)==""\n"
R"==(#define HALF_TO_DOUBLE1 convert_double)==""\n"
R"==(#define HALF_TO_DOUBLE8 convert_double8)==""\n"
R"==(#define FLOAT_TO_HALF1 convert_half)==""\n"
R"==(#define FLOAT_TO_HALF8 convert_half8)==""\n"
R"==(#define BFLOAT_TO_DOUBLE1 cvt_bf16_to_f64)==""\n"
R"==(#define BFLOAT_TO_DOUBLE8 cvt_bf16_to_f64)==""\n"
R"==(#define BFLOAT_TO_FLOAT1 cvt_bf16_to_f32)==""\n"
R"==(#define BFLOAT_TO_FLOAT8 cvt_bf16_to_f32)==""\n"
R"==(#define FLOAT_TO_BFLOAT1 cvt_f32_to_bf16)==""\n"
R"==(#define FLOAT_TO_BFLOAT8 cvt_f32_to_bf16)==""\n"
R"==(#define FLOAT_TO_FLOAT1 convert_float)==""\n"
R"==(#define FLOAT_TO_FLOAT8 convert_float8)==""\n"
R"==(#define FLOAT_TO_DOUBLE1 convert_double)==""\n"
R"==(#define FLOAT_TO_DOUBLE8 convert_double8)==""\n"
R"==(#define DOUBLE_TO_DOUBLE1 convert_double)==""\n"
R"==(#define DOUBLE_TO_DOUBLE8 convert_double8)==""\n"
R"==(#define DOUBLE_TO_FLOAT1 convert_float)==""\n"
R"==(#define DOUBLE_TO_FLOAT8 convert_float8)==""\n"
R"==(#define DATA_TO_FLOAT(prefix, val) DATA_TO_FLOAT_N(prefix, 1)(val))==""\n"
R"==(#define DATA_TO_FLOAT8(prefix, val) DATA_TO_FLOAT_N(prefix, 8)(val))==""\n"
R"==(#define DATA_TO_FLOAT_N(prefix, n) CONCAT3(ALIAS(prefix), _TO_FLOAT, n))==""\n"
R"==(#define DATA_TO_DOUBLE(prefix, val) DATA_TO_DOUBLE_N(prefix, 1)(val))==""\n"
R"==(#define DATA_TO_DOUBLE8(prefix, val) DATA_TO_DOUBLE_N(prefix, 8)(val))==""\n"
R"==(#define DATA_TO_DOUBLE_N(prefix, n) CONCAT3(ALIAS(prefix), _TO_DOUBLE, n))==""\n"
R"==(#define FLOAT_TO_DATA(prefix, val) FLOAT_TO_DATA_N(prefix, 1)(val))==""\n"
R"==(#define FLOAT_TO_DATA8(prefix, val) FLOAT_TO_DATA_N(prefix, 8)(val))==""\n"
R"==(#define FLOAT_TO_DATA_N(prefix, n) CONCAT3(FLOAT_TO_, ALIAS(prefix), n))==""\n"
R"==(#define DOUBLE_TO_DATA(prefix, val) DOUBLE_TO_DATA_N(prefix, 1)(val))==""\n"
R"==(#define DOUBLE_TO_DATA8(prefix, val) DOUBLE_TO_DATA_N(prefix, 8)(val))==""\n"
R"==(#define DOUBLE_TO_DATA_N(prefix, n) CONCAT3(DOUBLE_TO_, ALIAS(prefix), n))==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}